#include <stdio.h>
#include <stdlib.h>

#define MAXV 30000	/* Maximln poet vrchol */
#define MAXR 30000	/* Maximln poet ez */

/* Struktura pro jeden ez */
struct rez {
  int a, b;
};

int rezu, vrcholu;	/* Poet ez a vrchol */
struct rez r[MAXR];	/* Jednotliv ezy */
int vpoc[MAXV];		/* Poty ez zanajcch v jednotlivch vrcholech */

/* Nate vstup */
void nacti(void)
{
  int pom, i;
  FILE *vstup;

  if (!(vstup = fopen("poklad.in", "r")))
    exit(1);
  fscanf(vstup, "%d %d", &vrcholu, &rezu);
  for (i = 0; i < rezu; i++) {
    fscanf(vstup, "%d %d", &r[i].a, &r[i].b);
    r[i].a--; r[i].b--;
    if (r[i].a > r[i].b) {
      pom = r[i].a;
      r[i].a = r[i].b;
      r[i].b = pom;
    }
  }
  fclose(vstup);
  /* Pidme jet fiktivn ez mezi prvnm a poslednm vrcholem */
  r[rezu].a = 0;
  r[rezu].b = vrcholu-1;
  rezu++;
}

/* Setd ezy podle potku a konce */
void setrid(void)
{
  struct rez r1[MAXR];	/* Jednotliv peskldan ezy */
  int vrchind[MAXV];	/* Index, kde zanaj ezy z/do danho vrcholu */
  int vrchpoc[MAXV];	/* Poty ez z/do danho vrcholu */
  int i;

  /* Prvn prchod tdn */
  for (i = 0; i < vrcholu; i++)
    vrchpoc[i] = 0;
  /* Spoteme poty ez do jednotlivch vrchol */
  for (i = 0; i < rezu; i++)
    vrchpoc[r[i].b]++;
  vrchind[0] = 0;
  for (i = 1; i < vrcholu; i++)
    vrchind[i] = vrchind[i-1] + vrchpoc[i-1];
  /* Perovnme ezy podle clovho vrcholu */
  for (i = 0; i < rezu; i++)
    r1[vrchind[r[i].b]++] = r[i];

  /* Druh prchod tdn */
  for (i = 0; i < vrcholu; i++)
    vrchpoc[i] = 0;
  for (i = 0; i < rezu; i++)
    vrchpoc[r1[i].a]++;
  vrchind[0] = 0;
  for (i = 1; i < vrcholu; i++)
    vrchind[i] = vrchind[i-1] + vrchpoc[i-1];
  /* Perovnme ezy podle zdrojovho vrcholu (bereme je sestupn podle clovho vrcholu) */
  for (i = rezu-1; i >= 0; i--)
    r[vrchind[r1[i].a]++] = r1[i];
}

/* Spote, kolik st mapy me kapitn rozdat */
int spocti(void)
{
  int casti = 0;	/* Poet st */
  int zasvrch = 0;	/* Vrchol zsobnku */
  int zas[MAXR];	/* Zsobnk na zpracovvan ezy */
  int zasuzit[MAXR];	/* Znaka, e pslun st mapy me bt rozdna */
  int actvrch = 0, actrez = 0;	/* Aktuln vrchol a ez mnohohelnka */

  while (actvrch < vrcholu) {
    while (zasvrch && r[zas[zasvrch-1]].b == actvrch) {
      if (zasuzit[zasvrch-1]) {	/* st oddlen tmto ezem me bt pouita? */
        casti++;
        if (zasvrch > 1)
          zasuzit[zasvrch-2] = 0;
      }
      zasvrch--;
    }
    while (actrez < rezu && r[actrez].a == actvrch) {
      zas[zasvrch] = actrez++;
      zasuzit[zasvrch++] = 1;
    }
    actvrch++;
  }
  return casti;
}

int main(void)
{
  FILE *vystup;

  nacti();
  setrid();

  if (!(vystup = fopen("poklad.out", "w")))
    exit(1);
  fprintf(vystup, "%d\n", spocti());
  fclose(vystup);
  return 0;
}
